#ifndef _GPU_INTERNALS_H
#define _GPU_INTERNALS_H

#ifndef NOINCALLEGRO

#include <allegro.h>

extern BITMAP *vram;
extern BITMAP *drawvram;
#endif

extern long MemSize;

extern long textAddrY,textAddrX;

extern long textTP;
extern long textREST;
extern long textABR;

extern unsigned int GpuStatus;
extern unsigned int GpuInfo[8];
extern short TPage;
extern short clipX;
extern short clipY;
extern short clipW;
extern short clipH;
extern short offsX;
extern short offsY;
extern long tWinX;
extern long tWinY;
extern long tWinW;
extern long tWinH;
extern int md;
extern int me;

extern long dispWidths[4];
extern long imageTransfer;
extern long drawingLines;

extern unsigned int OldMode;
extern int Rgb24;

extern short imTYc,imTXc,imTY,imTX;
extern long imSize;
extern short imageX0,imageX1;
extern short imageY0,imageY1;

extern long newTextX0,newTextX1,newTextX2,newTextX3;
extern long newTextY0,newTextY1,newTextY2,newTextY3;

// Configure Structure

typedef struct {
    int FpsCount;		// frame counter
    int AlterDsp;		// use alternate display
    int VSync;			// wait for vsync - only without AlterDsp
    int Stretch;		// stretched - only with AlterDsp
    int FrameSkip;		// use frame skipping
    int DispW;			// display width - only with AlterDsp
    int DispH;			// display height - only with AlterDsp
    int CacheMode;		// caching mode
} GpuConf;

extern int norender;
extern GpuConf conf;

// Display Modes Structure

typedef struct {
    int bpp;
    int width;
    int height;
} DispModeS;

extern DispModeS DspModes[128];

#define DEF_WIDTH	640
#define DEF_HEIGHT	480
#define DEF_BPP		16

extern int Log;

void pslog(char *fmt, ...);

#define SetClip()	set_clip(vram, clipX, clipY, clipW, clipH);
#define UnsetClip()	set_clip(vram, 0, 0, 0, 0);
int SetDspMode(int w, int h, int bpp);
int SetViewPort(int x, int y);
void updateDisplay();
void AutoAlterDsp();

extern unsigned short bgr2rgb[65536];
void fillLookupTables();

#define MAKERGB15(r,g,b) ((((r)&0xf8)<<7) | (((g)&0xf8)<<2) | (((b)&0xf8)>>3))
#define MAKERGB24(r,g,b) (((r)<<16) | ((g)<<8) | (b))

extern unsigned char primTableC[256];
extern void (*primTableJ[256])(unsigned char *);

#endif // _GPU_INTERNALS_H