#ifndef __PRIM_H_
#define __PRIM_H_

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x0,y0;
	short x1,y1;
} LineF2;

typedef struct {
	unsigned char r0,g0,b0;
	unsigned char code;
	short x0,y0;
	unsigned char r1,g1,b1;
	char null;
	short x1,y1;
} LineG2;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x0,y0;
	short x1,y1;
	short x2,y2;
} PolyF3;

typedef struct {
	unsigned char r0,g0,b0;
	unsigned char code;
	short x0,y0;
	unsigned char r1,g1,b1;
	char null0;
	short x1,y1;
	unsigned char r2,g2,b2;
	char null1;
	short x2,y2;
} PolyG3;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x0,y0;
	short x1,y1;
	short x2,y2;
	short x3,y3;
} PolyF4;

typedef struct {
	unsigned char r0,g0,b0;
	unsigned char code;
	short x0,y0;
	unsigned char r1,g1,b1;
	char null0;
	short x1,y1;
	unsigned char r2,g2,b2;
	char null1;
	short x2,y2;
	unsigned char r3,g3,b3;
	char null2;
	short x3,y3;
} PolyG4;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x0,y0;
	unsigned char u0,v0;
	short clut;
	short x1,y1;
	unsigned char u1,v1;
	short tpage;
	short x2,y2;
	unsigned char u2,v2;
} PolyFT3;

typedef struct {
	unsigned char r0,g0,b0;
	unsigned char code;
	short x0,y0;
	unsigned char u0,v0;
	short clut;
	unsigned char r1,g1,b1;
	char null0;
	short x1,y1;
	unsigned char u1,v1;
	short tpage;
	unsigned char r2,g2,b2;
	char null1;
	short x2,y2;
	unsigned char u2,v2;
} PolyGT3;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x0,y0;
	unsigned char u0,v0;
	short clut;
	short x1,y1;
	unsigned char u1,v1;
	short tpage;
	short x2,y2;
	unsigned char u2,v2;
	short null;
	short x3,y3;
	unsigned char u3,v3;
} PolyFT4;

typedef struct {
	unsigned char r0,g0,b0;
	char code;
	short x0,y0;
	unsigned char u0,v0;
	short clut;
	unsigned char r1,g1,b1;
	char null0;
	short x1,y1;
	unsigned char u1,v1;
	short tpage;
	unsigned char r2,g2,b2;
	char null1;
	short x2,y2;
	unsigned char u2,v2;
	short null;
	unsigned char r3,g3,b3;
	char null2;
	short x3,y3;
	unsigned char u3,v3;
} PolyGT4;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x,y;
	short w,h;
} Rect;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x,y;
} RectWH;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x,y;
	unsigned char u,v;
	short clut;
	short w,h;
} Sprt;

typedef struct {
	unsigned char r,g,b;
	unsigned char code;
	short x,y;
	unsigned char u,v;
	short clut;
} SprtWH;

void drawSprite(SprtWH *prim, short w, short h);
void drawRect(RectWH *prim, short w, short h);

#endif